<template>
  <v-container>
    <v-row justify="space-between">
      <v-col cols="12" md="6">
        <p class="page-title">
          Información del Supervisor cliente
        </p>
      </v-col>
    </v-row>
    <v-card outlined class="mx-auto" max-width="100%">
      <!---<confirmation-modal :is-open="openModal" :modal-text="modalText" @confirm="confirmRegister" @cancel="cancelRegister" />--->
      <v-card-subtitle class="pb-0">
        <image-field v-model="supervisor.image" :disabled="disabled_user_info" :validation="imageValidation" />
        <v-divider></v-divider>
        <v-form ref="form" lazy-validation>
          <v-container fluid>
            <select-field  v-model="typeDocumentSelected" :items="typesDocument" fieldName="Tipo de documento" v-on:selectChange="changeSELECT"></select-field>
            <register-field-validation v-if="typeDocumentSelected==='DNI'" v-model="supervisor.document" field-name="DNI" :validation="DNIValidation" place-holder="Ingrese DNI" v-on:inputChange="changeDNI"/>
            <register-field-validation v-if="typeDocumentSelected==='CARNET EXTRANJERÍA'" v-model="supervisor.document" field-name="Carnet de extranjería" :validation="carnetValidation"  place-holder="Ingrese Carnet de extranjería"  v-on:inputChange="changeCarnetOrPassport"/>
            <register-field-validation v-if="typeDocumentSelected==='PASAPORTE'" v-model="supervisor.document" field-name="Pasaporte"  :validation="passportValidation" place-holder="Ingrese Pasaporte"  v-on:inputChange="changeCarnetOrPassport"/>

            <register-field-validation v-model="supervisor.name" :disabled="disabled_user_info || typeDocumentSelected=='DNI'" field-name="nombre" :validation="nameValidation" place-holder="Ingrese Nombre"  />
            <register-field-validation v-model="supervisor.fatherLastname" :disabled="disabled_user_info || typeDocumentSelected=='DNI'" field-name="Apellido Paterno" :validation="fatherLastnameValidation" place-holder="Ingrese Apellido Paterno" />
            <register-field-validation v-model="supervisor.motherLastname" :disabled="disabled_user_info || typeDocumentSelected=='DNI'" field-name="Apellido Materno " :validation="motherLastNameValidation" place-holder="Ingrese Apellido Materno" />
            <register-field-validation v-model="supervisor.email" :disabled="disabled_user_info" field-name="Correo" :validation="emailValidation" place-holder="Ingrese Correo"  />
            <register-field-validation v-model="supervisor.phoneNumber" :disabled="disabled_user_info" field-name="Celular" :validation="phoneValidation" place-holder="Ingrese Número Celular" :obligatory="false" />
<!---            <register-field-validation v-model="supervisor.address" :disabled="disabled_user_info" field-name="Domicilio"  place-holder="Ingrese Domicilio"  />---->
          </v-container>
        </v-form>
      </v-card-subtitle>
      <v-card-actions class="d-flex justify-end">
        <v-btn color="white" large rounded  @click="cancelForm()"> Regresar</v-btn>
        <register-button  button-name="GUARDAR" :outlined="false" @clicked="register()" />
      </v-card-actions>
      <br>
      <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
        {{ snackBar.text }}
        <template v-slot:action="{ attrs }">
          <v-btn color="blue" text v-bind="attrs" @click="snackBar.show = false">
            <v-icon>mdi-window-close</v-icon>
          </v-btn>
      </template>
      </v-snackbar>
    </v-card>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { DNIRules, nameRules, fatherLastnameRules, motherLastnameRules, emailRules, imageFileRules, phoneRules, carnetRules, passportRules } from "@/helpers/validation";
import RegisterFieldValidation from '~/components/InputField/RegisterFieldValidation';
import ButtonsRegisterForm from '~/components/InputField/ButtonsRegisterForm.vue';
import imageField from '~/components/InputField/ImageField';
import ConfirmationModal from '~/components/register/confirmationModal';
import SelectField from '~/components/InputField/SelectField.vue';

export default {
  name: 'RegisterClientSupervisor',
  components: { RegisterFieldValidation, ButtonsRegisterForm, imageField, ConfirmationModal, SelectField },
  data: () => ({
    typeDocumentSelected: 'DNI',
    typesDocument: ['CARNET EXTRANJERÍA', 'DNI', 'PASAPORTE'],
    disabled_user_info: true,
    isValidForm: false,
    DNIValidation: DNIRules,
    carnetValidation: carnetRules,
    passportValidation: passportRules,
    nameValidation: nameRules,
    fatherLastnameValidation: fatherLastnameRules,
    motherLastNameValidation: motherLastnameRules,
    emailValidation: emailRules,
    imageValidation: imageFileRules,
    phoneValidation: phoneRules,
    openModal: false,
    modalText: '¿Estás seguro que deseas registrar a este supervisor cliente?',
    snackBar: {
      show: false,
      color: '',
      text: '',
    },
    supervisor: {
      idCompany: '',
      image: null,
      document: '',
      typeDocument: '',
      name: '',
      fatherLastname: '',
      motherLastname: '',
      email: '',
      phoneNumber: '',
      address: '',
    },
  }),

  computed: {
    ...mapState({
      checkedClientSupervisor: state => state.client-supervisor.checkedClientSupervisor,
    }),
  },

  methods: {
    ...mapActions({
      storeClientSupervisor: 'client-supervisor/storeClientSupervisor',
      saveClientSupervisor: 'client-supervisor/saveClientSupervisor',
      checkedInformationClientSupervisor: 'client-supervisor/checkedInformationClientSupervisor',
    }),
    register() {
      if (this.$refs.form.validate()) {
        console.log('type document selected');
        console.log(this.typeDocumentSelected);
        this.supervisor.typeDocument = this.typeDocumentSelected;
        this.storeClientSupervisor(this.supervisor);
        console.log('store client supervisor');
        this.$emit('registerSupervisor');
      }
    },
    cancelForm() {
      this.$emit('regresar');
    },
    changeSELECT() {
      this.supervisor.document = '';
      this.clearForm();
    },
    async changeDNI(valid) {
      this.valid = valid;
      if (this.valid) {
        const checkedSupervisor = await this.checkedInformationClientSupervisor(this.supervisor.document);
        this.checkedUser(checkedSupervisor.data, this.typeDocumentSelected);
      } else {
        this.disabled_user_info = true;
      }
    },
    async changeCarnetOrPassport(valid) {
      this.valid = valid;
      if (valid) {
        this.disabled_user_info = false;
        const checkedSupervisor = await this.checkedInformationClientSupervisor(this.supervisor.document);
        this.checkedUserWithCarnetOrPassport(checkedSupervisor.data, this.typeDocumentSelected);
      } else {
        this.disabled_user_info = true;
      }
    },
    checkedUser(supervisor, typeDocumentSelected) {
      this.snackBar.color = 'primary';
      this.clearForm();
      this.disabled_user_info = true;

      /* If a user with this DNI doesn't exist */
      if (supervisor.user == null && supervisor.userApi == null) {
        this.setNackBar(typeDocumentSelected + ' INCORRECTO', 'error', true);
      }

      /* If a user found with API but doesn't register in BD */
      if (this.valid && supervisor.user == null && supervisor.userApi != null) {
        this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
        this.disabled_user_info = false;
        this.supervisor.name = supervisor.userApi.nombres;
        this.supervisor.fatherLastname = supervisor.userApi.apellidoPaterno;
        this.supervisor.motherLastname = supervisor.userApi.apellidoMaterno;
      }

      /* If a user with this DNI exist. And this user is NOT a specialist */
      if (this.valid && supervisor.user != null && !supervisor.isClientSupervisor) {
        this.ifUserRegisteredIsNotSupervisor(supervisor, typeDocumentSelected);
      }

      /* If a user with this DNI exist AND this user is a specialist */
      if (this.valid && supervisor.user != null && supervisor.isClientSupervisor) {
        this.ifUserRegisteredIsSupervisor(supervisor, typeDocumentSelected);
      }
    },
    checkedUserWithCarnetOrPassport(supervisor, typeDocumentSelected) {
      this.clearForm();
      this.disabled_user_info = true;

      /* If a user with this DNI is not registered in BD */
      if (this.valid && supervisor.user == null) {
        this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
        this.disabled_user_info = false;
      }
      /* If a user with this DNI exist. And this user is NOT a specialist */
      if (this.valid && supervisor.user != null && !supervisor.isClientSupervisor) {
        this.ifUserRegisteredIsNotSupervisor(supervisor, typeDocumentSelected);
      }
      /* If a user with this DNI exist AND this user is a specialist */
      if (this.valid && supervisor.user != null && supervisor.isClientSupervisor) {
        this.ifUserRegisteredIsSupervisor(supervisor, typeDocumentSelected);
      }
    },
    ifUserRegisteredIsNotSupervisor(supervisor, typeDocumentSelected) {
      this.setNackBar(typeDocumentSelected + ' vinculado a un usuario. Culmine el registro', 'primary', true);
      console.log(supervisor);
      this.supervisor = supervisor.user;
      this.disabled_specialist_info = false;
    },
    ifUserRegisteredIsSupervisor(supervisor, typeDocumentSelected) {
      this.setNackBar('Supervisor registrado con el ' + typeDocumentSelected + ' ingresado', 'error', true);
      this.supervisor = supervisor.user;
    },
    setNackBar(text, color, show) {
      this.snackBar.text = text;
      this.snackBar.show = show;
      this.snackBar.color = color;
    },
    clearForm() {
      this.supervisor.name = '';
      this.supervisor.fatherLastname = '';
      this.supervisor.motherLastname = '';
      this.supervisor.email = '';
      this.supervisor.phoneNumber = '';
      this.supervisor.address = '';
    },
  },
};
</script>

<style scoped>
.page-title {
  font-family: 'Montserrat', sans-serif;
  font-size: 1.5rem;
  margin-top: 1rem;
  margin-left: 1rem;
}
.buttonRegisterLeft {
  margin-top: 1rem;
}
.buttonRegisterRight {
  margin-top: 1rem;
}
</style>
